indexing
   description : "String interface for files"
   project     : "Eiffel-mmap"
   author      : "Pirmin Kalberer <kalberer@spin.ch>"
   copyright   : "Copyright (c) 1999, Pirmin Kalberer"
   date        : "$Date: 1999/12/04 23:12:02 $"
   revision    : "$Revision: 1.1 $"
	 
class EMMAP_FILE_STRING
   
inherit
   STRING
      undefine
	 append_string, append_character, prepend
      redefine
	 append
      end
   			
   EMMAP_FILE
      rename
	 make_open_read as emmap_file_make_open_read,
	 make_open_read_write as emmap_file_make_open_read_write
      undefine
	 out_in_tagged_out_memory, fill_tagged_out_memory,
	 is_equal
      end
   
creation
   make, make_open_read, make_open_read_write
   
feature
   
   make_open_read(fn: STRING) is
      require
	 string_exists: fn /= Void;
	 string_not_empty: not fn.empty
      do
	 emmap_file_make_open_read(fn)
	 storage := storage.from_pointer(addr_)
	 count := size
	 capacity := count
      end

   make_open_read_write(fn: STRING) is
      require
	 string_exists: fn /= Void;
	 string_not_empty: not fn.empty
      do
	 emmap_file_make_open_read_write(fn)
	 storage := storage.from_pointer(addr_)
	 count := size
	 capacity := count
      end

   append(other: STRING) is
      do
	 --nothing
      end

invariant
   const_size: count = capacity
    
end
